(******************************************************************************)
(*                                                                            *)
(*                               PROJECT HELM                                 *)
(*                                                                            *)
(*                Claudio Sacerdoti Coen <sacerdot@cs.unibo.it>               *)
(*                                 24/01/2000                                 *)
(*                                                                            *)
(* This module is the objects level of a parser for cic objects from xml      *)
(* files to the internal representation. It uses the module cicParser3        *)
(* cicParser3 (terms level) and it is used only through cicParser2 (top       *)
(* level).                                                                    *)
(*                                                                            *)
(******************************************************************************)

exception IllFormedXml of int
exception NotImplemented

(* This is the main function and also the only one used directly from *)
(* cicParser. Given the root of the dom tree, it returns the internal *)
(* representation of the cic object described in the tree             *)
(* It uses the previous functions and the to_cic_term method defined  *)
(* in cicParser3 (used for subtrees that encode cic terms)            *)
val get_term :
 < attribute : string -> Pxp_types.att_value;
   node_type : Pxp_document.node_type;
   sub_nodes : < attribute : string -> Pxp_types.att_value;
                 node_type : Pxp_document.node_type;
                 sub_nodes : CicParser3.cic_term Pxp_document.node list;
                 .. >
               list;
   .. > ->
 Cic.annobj
